//------------------------------------------------------------------------------
// shape_Constr.cpp -   
//  
//------------------------------------------------------------------------------

#include <iostream>
#include "shape_atd.h"

//------------------------------------------------------------------------------

namespace simple_shapes {

//------------------------------------------------------------------------------

  //       
  //  . ,  ,    .

  rectangle *Create_rectangle(int x, int y);
  triangle  *Create_triangle(int a, int b, int c);

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_rectangle(int x, int y)
  {
    shape *s = new shape;
    s->k = shape::key::RECTANGLE;
    s->s = (void*)Create_rectangle(x, y);
    return s;
  }

//------------------------------------------------------------------------------

  //    
  shape *Create_shape_triangle(int a, int b, int c)
  {
    shape *s = new shape;
    s->k = shape::key::TRIANGLE;
    s->s = (void*)Create_triangle(a, b, c);
    return s;
  }

//------------------------------------------------------------------------------


  //   
  void Init_rectangle(shape &s, int x, int y)
  {
    s.k = shape::key::RECTANGLE;
    //   ,   
    //   .
    s.s = (void*)Create_rectangle(x, y); 
  }

//------------------------------------------------------------------------------

  //   
  void Init_triangle(shape &s, int a, int b, int c)
  {
    s.k = shape::key::TRIANGLE;
    //   ,   
    //   .
    s.s = (void*)Create_triangle(a, b, c);
  }

//------------------------------------------------------------------------------

  //  ,    .
  //       
  //   .
  void Delete_rectangle(shape &s)
  {
    delete (rectangle*)s.s;
  }

//------------------------------------------------------------------------------

  //  ,    .
  //       
  //   .
  void Delete_triangle(shape &s)
  {
    delete (triangle*)s.s;
  }

//------------------------------------------------------------------------------

  //     .
  //   "" ,  
  //    .
  //   .  
  //  .
  void (*Clear_shape[])(shape &s) = 
    {&Delete_rectangle, &Delete_triangle};


  //     ,
  //      .
  //  .
  void Clear(shape &s)
  {
    Clear_shape[s.k](s);
  }

//------------------------------------------------------------------------------


} // end simple_shapes namespace
